mod body;
#[doc(hidden)]
pub mod form;
mod from_body;

pub use self::body::Body;
pub use self::form::{Form, FromForm};
pub use self::from_body::FromBody;

use futures::future::{self, FutureResult};
use hyper::Chunk;
use errors::HandleError;

#[doc(hidden)]
pub fn fold_fn(mut body: Vec<u8>, chunk: Chunk) -> FutureResult<Vec<u8>, HandleError> {
    body.extend_from_slice(&chunk);
    future::ok(body)
}
