use hyper::{Request as HyperRequest, Method, Uri, HttpVersion, Headers, Body};


/// HTTP request, reconstructed from `hyper::Request`.
pub struct Request {
    pub method: Method,
    pub http_version: HttpVersion,
    pub uri: Uri,
    pub headers: Headers,
}

impl Request {
    /// Returns the path of request URL.
    pub fn path(&self) -> &str {
        self.uri.path()
    }
}

pub fn reconstruct(req: HyperRequest) -> (Request, Body) {
    let (method, uri, http_version, headers, body) = req.deconstruct();
    let req = Request {
        method,
        uri,
        http_version,
        headers,
    };
    (req, body)
}
