use hyper::Response as RawResponse;

pub type Callback = fn(&mut RawResponse);


/// [unstable] A response which contains all information to construct
pub struct Response {
    raw: RawResponse,
}

impl Response {
    pub fn apply_callbacks<I>(&mut self, callbacks: I)
    where
        I: IntoIterator<Item = Callback>,
    {
        for callback in callbacks {
            callback(&mut self.raw);
        }
    }

    pub(crate) fn into_raw(self) -> RawResponse {
        self.raw
    }
}

impl From<RawResponse> for Response {
    fn from(raw: RawResponse) -> Self {
        Response { raw }
    }
}
